import serial
import array
import sys
import time
import threading
import os
import errno

ser = serial.Serial(
    port='/dev/ttyUSB0',
    baudrate=19200,
    parity=serial.PARITY_NONE,
    stopbits=serial.STOPBITS_ONE,
    bytesize=serial.EIGHTBITS,
    timeout=0
)
ser.isOpen()

try:
    print "Loading ANT Queen 9000..."
    print "Trying to create FIFO's..."
    fifoin = "/var/www/zphone/gehrke/device-io/antfifo_in"
    os.mkfifo(fifoin)
    fifoout = "/var/www/zphone/gehrke/device-io/antfifo_out"
    os.mkfifo(fifoout)
except:
    print "FIFO's already exist..."

def read_from_port(ser):
    try:
        while True:
	    #Check for incoming commands
	    try:
		print "Checking FIFO for cmd..."
                io = open("/var/www/zphone/gehrke/device-io/antfifo_in", "r")
		for line in io:
		    buffer = line
                io.close()
	    except OSError as err:
	        if err.errno == errno.EAGAIN or err.errno == errno.EWOULDBLOCK:
	            buffer = None
		    print "Error: " + err
	        else:
		    raise

	    #Creating output buffer
	    out = ''

	    if(len(buffer)>=2):
                print "FIFO cmd received: " + buffer
	        #Calculate CRC8 (BCC)
	        cmdstr = buffer
	        lengthstr = hex(len(cmdstr)+1)
		dezstring = [str(ord(c)) for c in cmdstr]
		msgByteArray = list()
		tmpList = [str(lengthstr[2:])]
		msgByteArray.extend(tmpList)
		msgByteArray.extend(dezstring)
		msgByteArray.extend(str(00))
		bcc = int(msgByteArray[0],16)
		print "Calculating BCC..."
		for i in range(1,int(lengthstr,16)):
	            bcc = bcc ^ int(msgByteArray[i])

	        #Prepare final command
	        print "Preapring final byte array..."
		hexstring = ''.join(c.encode("hex") for c in cmdstr)
	        finalcmd = ''.join(hexstring)
	        size = str(lengthstr[2:])
		if(len(size)<=1):
	            size = "0" + str(size)

	        #Link parts, send to serial & wait for answer
	        print "Putting the puzzle parts together..."
		input = "02"+size+str(finalcmd)+str(chr(bcc).encode("hex"))+"03"
                print "Sending: " + input + " to HAL9000..."
	        ser.write(input.decode("hex") + '\r\n')

	    elif(len(buffer)==1):
		print "Received magic byte"
		out += "Antqueen alive!"

	    #Write output to fifo
	    print "Waiting for feedback..."
            time.sleep(1)
            while(ser.inWaiting() > 0):
                out += ser.read(1)
            if out != '':
                print ">>" + out
                outfifo = open("/var/www/zphone/gehrke/device-io/antfifo_out", 'w', 0)
                outfifo.write(out)
		outfifo.close()
    except:
    	open("/tmp/antqueen.crash", 'a').close()
    	raise

thread = threading.Thread(target=read_from_port, args=(ser,))
thread.start()
